%if 0

lDebug assembler/immediate execution handler

Copyright (C) 2008-2012 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif


	usesection lDEBUG_CODE

immasm:
	call skipcomma
	mov byte [ ia_exec ], 0
	cmp al, '.'			; second dot ?
	jne .nodot			; no -->
	inc byte [ ia_exec ]		; note it
	call skipcomma			; skip it
.nodot:
	call iseol?
	je short .ret_e			; empty -->

	call guard_auxbuff

	push ax
	push si

	mov si, a_addr
	mov di, ia_savedaddr
	movsw
	movsw
	movsw				; save A command address
	mov word [ ia_restore ], ia_restore_a_addr

	push es
	mov es, word [auxbuff_segorsel]
	xor di, di
	mov word [ a_addr+4 ], es
_386_PM	and word [ a_addr+2 ], byte 0
	mov word [ a_addr+0 ], di	; initialize address
	mov byte [ asm_mn_flags ], 0	; some flags for assembler

	mov cx, _AUXBUFFSIZE
	mov al, 0CCh
	rep stosb			; initialize buffer
	pop es

	pop si
	pop ax
	mov word [ aa_ret ], .aa_ret	; make assembler return here
	mov word [ ia_sp ], sp		; (possibly unnecessary)
	jmp aa_imm_entry

.aa_ret:
	mov sp, word [ ia_sp ]
	push ss
	pop ds
	push ss
	pop es

		; dwo [a_addr] - dwo [ia_savedaddr] = len of opcode

	call ia_restore_a_addr

		; for now, disassemble the result
	mov si, u_addr
	mov di, ia_savedaddr
	movsw
	movsw
	movsw				; save U command address
	mov word [ ia_restore ], ia_restore_u_addr

	mov ax, word [auxbuff_segorsel]
	mov word [ u_addr+4 ], ax
_386_PM	and word [ u_addr+2 ], byte 0
	and word [ u_addr+0 ], byte 0	; initialize address

	mov byte [disflags], DIS_F_REPT | DIS_F_SHOW
	call disasm

	push ss
	pop ds
	push ss
	pop es

	call ia_restore_u_addr

	cmp byte [ ia_exec ], 0		; test execution ?
.ret_e:
	je short .ret			; no -->

	mov si, reg_eip
	mov di, ia_savedcseip
	movsw
_386_PM	movsw
	mov si, reg_cs
	movsw				; save CS:(E)IP (U command address still saved)
	mov word [ ia_restore ], ia_restore_cseip_and_u_addr

%if _PM
 %error Wrong cs
%endif
	mov ax, word [auxbuff_segorsel]
	mov word [ reg_cs ], ax
_386_PM	and word [ reg_eip+2 ], byte 0
	and word [ reg_eip+0 ], byte 0	; initialize address

	call traceone			; trace one instruction
	jc unexpectedinterrupt		; --> (returns to cmd3)
	call dumpregs_no_disasm		; dump registers (only)
.ret:
	jmp cmd3


ia_restore_a_addr:
	mov di, a_addr
.common_u:
	mov si, ia_savedaddr
	movsw
	movsw
	movsw				; restore address
	mov word [ ia_restore ], ia_restore_none
ia_restore_none:
	retn

ia_restore_cseip_and_u_addr:
	mov di, reg_eip
	mov si, ia_savedcseip
	movsw
_386_PM	movsw
	mov di, reg_cs
	movsw

ia_restore_u_addr:
	mov di, u_addr
	jmp short ia_restore_a_addr.common_u


	usesection lDEBUG_DATA_ENTRY

	align 2, db 0
ia_savedaddr:	dw 0,0,0		; a_addr or u_addr
ia_savedcseip:	dw 0,0,0		; CS:(E)IP
ia_restore:	dw ia_restore_none	; called by cmd3
ia_sp:		dw 0
ia_exec:	db 0
